#INCLUDE "dcdialog.CH"

#define CRLF Chr(13)+Chr(10)

*

****************
CLASS MyTestVars FROM CustomWebHandler
****************

  EXPORTED:
    CLASS VAR aRemoteIPs
    CLASS VAR aVariables     // == aSessions

  EXPORTED:
    METHOD initVars   //, AddIP, MyGetValue, MySetValue

ENDCLASS

*

*****************
METHOD MyTestVars:InitVars()
*****************

wtf ::HttpRequest:GetVariable("REMOTE_ADDR")

DEFAULT ::aRemoteIPs := {}
DEFAULT ::aVariables := {}

wtf ::aRemoteIPs, ::aVariables

RETURN self


*************************************************************************


**********
* CLASS Test FROM MyTestVars
CLASS Test FROM CustomWebHandler
**********

/*
  HIDDEN:
  CLASS VAR chaTime          // ClassHidden aTime
  CLASS VAR chaString
  CLASS VAR chnCount

  VAR haTime                 // Hidden aTime
  VAR haString
  VAR hnCount


  PROTECTED:
  CLASS VAR cpaTime          // ClassProtected aTime
  CLASS VAR cpaString
  CLASS VAR cpnCount

  VAR paTime                 // Protected aTime
  VAR paString
  VAR pnCount
*/

  EXPORTED:
    CLASS VAR ceaTime        // ClassExported aTime
    CLASS VAR ceaString
    CLASS VAR cenCount

    VAR eaTime               // Exported aTime
    VAR eaString
    VAR enCount

* if derived from MyTestVars, mark it out
    CLASS VAR aRemoteIPs
    CLASS VAR aVariables     // == aSessions

  EXPORTED:
    METHOD echo, getTime, echoVars, crash, echoHtml, initVars, AddIP, MyGetValue, MySetValue

ENDCLASS


* --------


***********
METHOD Test:InitVars()
***********

wtf ::HttpRequest:GetVariable("REMOTE_ADDR")
/*
DEFAULT ::chaTime   := {}
DEFAULT ::chaString := {}
DEFAULT ::chnCount  := 0
*
DEFAULT ::haTime   := {}
DEFAULT ::haString := {}
DEFAULT ::hnCount  := 0


DEFAULT ::cpaTime   := {}
DEFAULT ::cpaString := {}
DEFAULT ::cpnCount  := 0
*
DEFAULT ::paTime   := {}
DEFAULT ::paString := {}
DEFAULT ::pnCount  := 0
*/

DEFAULT ::ceaTime   := {}
DEFAULT ::ceaString := {}
DEFAULT ::cenCount  := 0
*
DEFAULT ::eaTime   := {}
DEFAULT ::eaString := {}
DEFAULT ::enCount  := 0


* if derived from MyTestVars, mark it out
DEFAULT ::aRemoteIPs := {}
DEFAULT ::aVariables := {}


RETURN self

*

*****************
METHOD Test:AddIP()
*****************

Local cRemoteIP := ::HttpRequest:GetVariable("REMOTE_ADDR")
*
Local aVariables := ;
  { { 'cTest', '' }, ;
    { 'nTest', 0  }, ;
    { 'aTest', {} }  ;
  }
* Local nAt := 0

* ::InitVars()

wtf cRemoteIP
wtf ::aRemoteIPs
wtf aVariables
* nAt := AScan( ::aRemoteIPs, { |x| x == cRemoteIP } )
* wtf nAt
* If ( nAt == 0 )
If ( AScan( ::aRemoteIPs, { |x| x == cRemoteIP } ) == 0 )
   AAdd( ::aRemoteIPs, cRemoteIP )
   AAdd( ::aVariables, { cRemoteIP, Time(), AClone( aVariables ) } )
   wtf 'added'
Else
   wtf '!added, already included'
EndIf

wtf ::aRemoteIPs, ::aVariables
RETURN self

*

**********************
METHOD Test:MySetValue( _cVarName, xValue )
**********************

Local cRemoteIP := ::HttpRequest:GetVariable("REMOTE_ADDR")
* Local nPos      := AScan( ::aRemoteIPs, { |x| x == cRemoteIP } )
Local nPos      := 0
Local nAt       := 0
* Local aTemp := {}

wtf cRemoteIP

/*
nPos := AScan( ::aRemoteIPs, { |x| x == cRemoteIP } )
wtf nPos

aTemp := AClone( ::aVariables[ nPos, 3 ] )
wtf aTemp

nAt := AScan( aTemp, { |x| x[1] == _cVarName } )
wtf nAt
If ( nAt > 0 )
   aTemp[ nAt, 2 ] := xValue
   ::aVariables[ nPos, 3 ] := AClone( aTemp )
Else
   wtf 'variable ' + _cVarName + ' not exist'
EndIf

wtf aTemp
wtf ::aVariables pause
*/


nPos := AScan( ::aVariables, { |x| x[1] == cRemoteIP } )
wtf nPos

wtf ::aVariables[nPos]
wtf ::aVariables[nPos,3] /*pause*/

nAt := AScan( ::aVariables[nPos,3], { |x| x[1] == _cVarName } )
wtf nAt /*pause*/

If ( nAt > 0 )
   ::aVariables[ nPos, 3, nAt, 2 ] := xValue
Else
   wtf 'variable ' + _cVarName + ' not exist'
EndIf

wtf _cVarName, xValue, ::aVariables /*pause*/

RETURN self

*

**********************
METHOD Test:MyGetValue( _cVarName )
**********************

Local cRemoteIP := ::HttpRequest:GetVariable("REMOTE_ADDR")
* Local nPos      := AScan( ::aRemoteIPs, { |x| x == cRemoteIP } )
Local nPos      := 0
Local nAt       := 0
Local xValue    := NIL
* Local aTemp := {}

/*
nPos      := AScan( ::aRemoteIPs, { |x| x == cRemoteIP } )
wtf cRemoteIP, nPos

aTemp := AClone( ::aVariables[ nPos, 3 ] )
wtf aTemp

nAt := AScan( aTemp, { |x| x[1] == _cVarName } )
wtf nAt
If ( nAt > 0 )
   xValue := aTemp[ nAt, 2 ]
Else
   wtf 'variable ' + _cVarName + ' not exist'
EndIf
*/

nPos := AScan( ::aVariables, { |x| x[1] == cRemoteIP } )
wtf nPos

wtf ::aVariables[nPos]
wtf ::aVariables[nPos,3] /*pause*/

nAt := AScan( ::aVariables[nPos,3], { |x| x[1] == _cVarName } )
wtf nAt /*pause*/

If ( nAt > 0 )
   xValue := ::aVariables[ nPos, 3, nAt, 2 ]
Else
   wtf 'variable ' + _cVarName + ' not exist'
EndIf

wtf _cVarName, xValue, ::aVariables /*pause*/

RETURN xValue

*

****************
METHOD Test:echo( cParamName1 )
****************

LOCAL cHtml      := ""
Local cRemoteIP  := ''
Local nPos       := 0

::setErrorBlock()

BEGIN SEQUENCE


* if derived from MyTestVars, un-mark it
* MyTestVars():InitVars()


::initVars()

::AddIP()


cRemoteIP := ::HttpRequest:GetVariable("REMOTE_ADDR")
nPos      := AScan( ::aRemoteIPs, { |x| x == cRemoteIP } )


/*
AAdd( ::chaTime, Time() )
::chnCount ++

AAdd( ::haTime, Time() )
::hnCount ++

*

AAdd( ::cpaTime, Time() )
::cpnCount ++

AAdd( ::paTime, Time() )
::pnCount ++

*/

AAdd( ::ceaTime, Time() )
::cenCount ++

AAdd( ::eaTime, Time() )
::enCount ++

*

cHtml += "<html><title>Test:echo() was called</title><body>"
cHtml += '<pre>'
cHtml += "Parameter cParamName1 is " + ::httpRequest:form:getCollection()[1,1] + CRLF
cHtml += DC_Array2String(::httpRequest:form:getCollection()) + CRLF
cHtml += 'Pcount is: ' + Alltrim(Str(Pcount())) + CRLF
cHtml += 'Query String is: ' + ::httpRequest:getQueryString() + '</br>' + CRLF

cHtml += '</br>'+ CRLF

cHtml += 'nPos: ' + Var2Char( nPos ) + CRLF
cHtml += 'cRemoteIP: ' + Var2Char( cRemoteIP ) + CRLF
cHtml += 'aRemoteIPs: ' + Var2Char( ::aRemoteIPs ) + CRLF
cHtml += 'aVariables: ' + Var2Char( ::aVariables ) + CRLF
cHtml += '</br>'+ CRLF

cHtml += 'Value-nTest: ' + Var2Char( ::MyGetValue( 'nTest' ) ) + CRLF
cHtml += 'Value- Test: ' + Var2Char( ::MyGetValue( 'nTest' ) > 0 ) + CRLF

::MySetValue( 'nTest', nPos /*1*/ )
* ::MySetValue( 'xxxnTest', nPos /*1*/ )

cHtml += 'Value-nTest: ' + Var2Char( ::MyGetValue( 'nTest' ) ) + CRLF
cHtml += '</br>'+ CRLF

/*
cHtml += 'chaTime: ' + Var2Char( ::chnCount ) + ' - '  + Var2Char( ::chaTime ) + CRLF
cHtml += 'haTime : ' + Var2Char( ::hnCount ) + ' - '  + Var2Char( ::haTime ) + CRLF
cHtml += '</br>'+ CRLF

cHtml += 'cpaTime: ' + Var2Char( ::cpnCount ) + ' - '  + Var2Char( ::cpaTime ) + CRLF
cHtml += 'paTime : ' + Var2Char( ::pnCount ) + ' - '  + Var2Char( ::paTime ) + CRLF
cHtml += '</br>'+ CRLF
*/

cHtml += 'ceaTime: ' + Var2Char( ::cenCount ) + ' - '  + Var2Char( ::ceaTime ) + CRLF
cHtml += 'eaTime : ' + Var2Char( ::enCount ) + ' - '  + Var2Char( ::eaTime ) + CRLF
cHtml += '</br>'+ CRLF

cHtml += "</pre></body></html>"

RECOVER USING cHtml

END SEQUENCE

RETURN cHtml

*

********************
METHOD Test:echoVars()
********************

LOCAL cResponse, aVars, i, oForm
*
Local cRemoteIP  := ''
Local nPos       := 0

::setErrorBlock()
BEGIN SEQUENCE

::initVars()

::AddIP()


cRemoteIP := ::HttpRequest:GetVariable("REMOTE_ADDR")
nPos      := AScan( ::aRemoteIPs, { |x| x == cRemoteIP } )

/*
AAdd( ::chaTime, Time() )
::chnCount ++

AAdd( ::haTime, Time() )
::hnCount ++

*

AAdd( ::cpaTime, Time() )
::cpnCount ++

AAdd( ::paTime, Time() )
::pnCount ++

*/

AAdd( ::ceaTime, Time() )
::cenCount ++
AAdd( ::eaTime, Time() )
::enCount ++

*

oForm := ::httpRequest:getForm()
aVars := oForm:getCollection()
cResponse := '<H1> Echoing all Vars </H1>'
cResponse += '<pre>' + CRLF

FOR i := 1 TO Len(aVars)
  cResponse += aVars[i,1] + ' : ' + aVars[i,2] + CRLF
NEXT

cResponse += '</br>'+ CRLF



cResponse += 'nPos: ' + Var2Char( nPos ) + CRLF
cResponse += 'cRemoteIP: ' + Var2Char( cRemoteIP ) + CRLF
cResponse += 'aRemoteIPs: ' + Var2Char( ::aRemoteIPs ) + CRLF
cResponse += 'aVariables: ' + Var2Char( ::aVariables ) + CRLF
cResponse += '</br>'+ CRLF

cResponse += 'Value-nTest: ' + Var2Char( ::MyGetValue( 'nTest' ) ) + CRLF
cResponse += 'Value- Test: ' + Var2Char( ::MyGetValue( 'nTest' ) > 0 ) + CRLF

::MySetValue( 'nTest', nPos /*1*/ )
* ::MySetValue( 'xxxnTest', nPos /*1*/ )

cResponse += 'Value-nTest: ' + Var2Char( ::MyGetValue( 'nTest' ) ) + CRLF
cResponse += '</br>'+ CRLF


/*
cResponse += 'chaTime: ' + Var2Char( ::chnCount ) + ' - '  + Var2Char( ::chaTime ) + '</br>'+ CRLF
cResponse += 'haTime : ' + Var2Char( ::hnCount ) + ' - '  + Var2Char( ::haTime ) + '</br>'+ CRLF
cResponse += '</br>'+ CRLF

cResponse += 'cpaTime: ' + Var2Char( ::cpnCount ) + ' - '  + Var2Char( ::cpaTime ) + '</br>'+ CRLF
cResponse += 'paTime : ' + Var2Char( ::pnCount ) + ' - '  + Var2Char( ::paTime ) + '</br>'+ CRLF
cResponse += '</br>'+ CRLF
*/

cResponse += 'ceaTime: ' + Var2Char( ::cenCount ) + ' - '  + Var2Char( ::ceaTime ) + CRLF
cResponse += 'eaTime : ' + Var2Char( ::enCount ) + ' - '  + Var2Char( ::eaTime ) + CRLF
cResponse += '</br>'+ CRLF

cResponse += '</pre>'

RECOVER USING cResponse
END SEQUENCE

RETURN cResponse

* ------------

//
// The method :get() handles the RESTful path CurrentTime/get
//
*******************
METHOD Test:getTime()
*******************

LOCAL cThreadId
LOCAL cResponse := ""
*
Local cRemoteIP  := ''
Local nPos       := 0

cThreadId := AllTrim(Str(ThreadId()))

::setErrorBlock()

BEGIN SEQUENCE

::initVars()

::AddIP()


cRemoteIP := ::HttpRequest:GetVariable("REMOTE_ADDR")
nPos      := AScan( ::aRemoteIPs, { |x| x == cRemoteIP } )


/*
AAdd( ::chaTime, Time() )
::chnCount ++

AAdd( ::haTime, Time() )
::hnCount ++

*

AAdd( ::cpaTime, Time() )
::cpnCount ++

AAdd( ::paTime, Time() )
::pnCount ++

*/

AAdd( ::ceaTime, Time() )
::cenCount ++
AAdd( ::eaTime, Time() )
::enCount ++

*

cResponse += "<!DOCTYPE html>"
cResponse += "<html>"
cResponse +=   "<head><title>"+ProcName()+"</title></head>"
cResponse +=   "<body>"
cResponse +=     "<h1>Current Time:</h1>"
cResponse +=     "<p>"+Time()+" (HH:MM:SS)</p>"
cResponse +=     "<small>By thread: "+cThreadId+"</small>"

cResponse += '</br>'+ CRLF
cResponse += '</br>'+ CRLF


cResponse += 'nPos: ' + Var2Char( nPos ) + '</br>' + CRLF
cResponse += 'cRemoteIP: ' + Var2Char( cRemoteIP ) + '</br>' + CRLF
cResponse += 'aRemoteIPs: ' + Var2Char( ::aRemoteIPs ) + '</br>' + CRLF
cResponse += 'aVariables: ' + Var2Char( ::aVariables ) + '</br>' + CRLF
cResponse += '</br>'+ CRLF

cResponse += 'Value-nTest: ' + Var2Char( ::MyGetValue( 'nTest' ) ) + '</br>' + CRLF
cResponse += 'Value- Test: ' + Var2Char( ::MyGetValue( 'nTest' ) > 0 ) + '</br>' + CRLF

::MySetValue( 'nTest', nPos /*1*/ )
* ::MySetValue( 'xxxnTest', nPos /*1*/ )

cResponse += 'Value-nTest: ' + Var2Char( ::MyGetValue( 'nTest' ) ) + '</br>' + CRLF
cResponse += '</br>'+ CRLF


/*
cResponse += 'chaTime: ' + Var2Char( ::chnCount ) + ' - '  + Var2Char( ::chaTime ) + '</br>'+ CRLF
cResponse += 'haTime : ' + Var2Char( ::hnCount ) + ' - '  + Var2Char( ::haTime ) + '</br>'+ CRLF
cResponse += '</br>'+ CRLF

cResponse += 'cpaTime: ' + Var2Char( ::cpnCount ) + ' - '  + Var2Char( ::cpaTime ) + '</br>'+ CRLF
cResponse += 'paTime : ' + Var2Char( ::pnCount ) + ' - '  + Var2Char( ::paTime ) + '</br>'+ CRLF
cResponse += '</br>'+ CRLF
*/

cResponse += 'ceaTime: ' + Var2Char( ::cenCount ) + ' - '  + Var2Char( ::ceaTime ) + '</br>'+ CRLF
cResponse += 'eaTime : ' + Var2Char( ::enCount ) + ' - '  + Var2Char( ::eaTime ) + '</br>'+ CRLF
cResponse += '</br>'+ CRLF

cResponse +=   "</body>"
cResponse += "</html>"

RECOVER USING cResponse

END SEQUENCE

RETURN cResponse

* -----------

*****************
METHOD Test:crash()
*****************

LOCAL cResponse

::setErrorBlock()

BEGIN SEQUENCE

&('CrashThisProgram()')

RECOVER USING cResponse

END SEQUENCE

RETURN cResponse

*

********************
METHOD Test:echoHtml( cHtml )
********************

DEFAULT cHtml := 'No Html exists'

RETURN MemoRead(cHtml)

*
